-----------------------------------------------------------
--                   Eiffel/S libraries                  --
-----------------------------------------------------------
--               Copyright (C) 1991 - 1993               --
--                           by                          --
--                   SiG Computer GmbH                   --
--                  All rights reserved                  --
-----------------------------------------------------------
-- Release : 1.3 - October 1993                          --
-----------------------------------------------------------
-- Authors : Lambert Strether & Michael Schweitzer       --
-----------------------------------------------------------
  
expanded class BOOLEAN

inherit
    BOOLEAN_REF
        rename
            make as bool_usesless

        redefine
            infix "and", infix "and then", infix "or",
            infix "or else", infix "implies", infix "xor",
            prefix "not"
    end
-----------------------------------------------------------
feature {ANY}
-----------------------------------------------------------

    infix "and" (other : BOOLEAN) : BOOLEAN is
                        -- `and' of Current with `other'.
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    infix "and then" (other : BOOLEAN) : BOOLEAN is
                        -- Semi-strict `and' of Current with `other'.
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    infix "implies" (other : BOOLEAN) : BOOLEAN is
                        -- Does Current imply `other'.
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    infix "or" (other : BOOLEAN) : BOOLEAN is
                        -- `or' of Current with `other'
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    infix "or else" (other : BOOLEAN) : BOOLEAN is
                        -- Semi-strict `or' of Current with `other'
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    infix "xor" (other : BOOLEAN) : BOOLEAN is
                        -- `xor' of Current with `other'
        do
            -- This is a dummy
        end
-----------------------------------------------------------

    prefix "not" : BOOLEAN is
                        -- `not' of Current.
        do
            -- This is a dummy
        end
-----------------------------------------------------------

end -- class BOOLEAN

